diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/wifi-channel-switching-test.cc ns-3.36/src/wifi/test/wifi-channel-switching-test.cc
--- ns-3.35/src/wifi/test/wifi-channel-switching-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/wifi/test/wifi-channel-switching-test.cc	2022-04-30 18:23:58.218735200 -0700
@@ -0,0 +1,314 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/test.h"
+#include "ns3/string.h"
+#include "ns3/boolean.h"
+#include "ns3/qos-utils.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-net-device.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/mobility-helper.h"
+#include "ns3/spectrum-wifi-helper.h"
+#include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/packet-socket-server.h"
+#include "ns3/packet-socket-client.h"
+#include "ns3/packet-socket-helper.h"
+#include "ns3/rng-seed-manager.h"
+#include "ns3/config.h"
+#include <array>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("WifiChannelSwitchingTest");
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * This test verifies that communication between an AP and a STA resumes
+ * after that both switch channel and PHY band. The channel switch is
+ * scheduled to happen during the transmission of a frame sent by the AP
+ * to the STA. STA discards the frame, associates with the AP again and
+ * finally receives the frame successfully.
+ */
+class WifiChannelSwitchingTest : public TestCase
+{
+public:
+  /**
+   * \brief Constructor
+   */
+  WifiChannelSwitchingTest ();
+  virtual ~WifiChannelSwitchingTest ();
+
+  virtual void DoRun (void);
+
+  /**
+   * Callback invoked when a station associates with an AP. Tracks the number of
+   * times the association procedure is performed.
+   *
+   * \param bssid the BSSID
+   */
+  void Associated (Mac48Address bssid);
+  /**
+   * Callback invoked when PHY receives a PSDU to transmit from the MAC. Tracks the
+   * number of times a QoS data frame is transmitted by the AP.
+   *
+   * \param psduMap the PSDU map
+   * \param txVector the TX vector
+   * \param txPowerW the tx power in Watts
+   */
+  void Transmit (WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW);
+  /**
+   * Function to trace packets received by the server application
+   *
+   * \param p the packet
+   * \param addr the address
+   */
+  void L7Receive (Ptr<const Packet> p, const Address &addr);
+  /**
+   * Send a packet from the AP to the STA through a packet socket
+   */
+  void SendPacket (void);
+  /**
+   * Request channel switch on both AP and STA
+   */
+  void ChannelSwitch (void);
+  /**
+   * Callback invoked when the PHY on the given node changes state.
+   *
+   * \param nodeId the given node ID
+   * \param start the time state changes
+   * \param duration the time the PHY will stay in the new state
+   * \param state the new PHY state
+   */
+  void StateChange (uint32_t nodeId, Time start, Time duration, WifiPhyState state);
+
+private:
+  NodeContainer m_apNode;             ///< AP node container
+  NodeContainer m_staNode;            ///< STA node container
+  NetDeviceContainer m_apDevice;      ///< AP device container
+  NetDeviceContainer m_staDevice;     ///< STA device container
+  uint8_t m_assocCount;               ///< count of completed Assoc Request procedures
+  uint8_t m_txCount;                  ///< count of transmissions
+  uint64_t m_rxBytes;                 ///< RX bytes
+  uint32_t m_payloadSize;             ///< payload size in bytes
+  std::array<uint8_t, 2> m_channelSwitchCount {0, 0}; ///< Per-node number of channel switch events
+};
+
+WifiChannelSwitchingTest::WifiChannelSwitchingTest ()
+  : TestCase ("Test case for resuming data transmission when the recipient moves back"),
+    m_assocCount (0),
+    m_txCount (0),
+    m_rxBytes (0),
+    m_payloadSize (2000)
+{
+}
+
+WifiChannelSwitchingTest::~WifiChannelSwitchingTest ()
+{
+}
+
+void
+WifiChannelSwitchingTest::Associated (Mac48Address bssid)
+{
+  m_assocCount++;
+}
+
+void
+WifiChannelSwitchingTest::Transmit (WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW)
+{
+  for (const auto& psduPair : psduMap)
+    {
+      std::stringstream ss;
+      ss << " " << psduPair.second->GetHeader (0).GetTypeString ()
+         << " seq " << psduPair.second->GetHeader (0).GetSequenceNumber ()
+         << " from " << psduPair.second->GetAddr2 ()
+         << " to " << psduPair.second->GetAddr1 ();
+      NS_LOG_INFO (ss.str ());
+    }
+  NS_LOG_INFO (" TXVECTOR " << txVector << "\n");
+
+  if (psduMap.begin ()->second->GetHeader (0).IsQosData ())
+    {
+      m_txCount++;
+
+      if (!psduMap.begin ()->second->GetHeader (0).IsRetry ())
+        {
+          // packet transmitted after first association. Switch channel during its
+          // transmission
+          Time txDuration = WifiPhy::CalculateTxDuration (psduMap, txVector, WIFI_PHY_BAND_5GHZ);
+          Simulator::Schedule (txDuration / 2, &WifiChannelSwitchingTest::ChannelSwitch, this);
+        }
+    }
+}
+
+void
+WifiChannelSwitchingTest::L7Receive (Ptr<const Packet> p, const Address &addr)
+{
+  if (p->GetSize () == m_payloadSize)
+    {
+      m_rxBytes += m_payloadSize;
+    }
+}
+
+void
+WifiChannelSwitchingTest::SendPacket (void)
+{
+  PacketSocketAddress socket;
+  socket.SetSingleDevice (m_apDevice.Get (0)->GetIfIndex ());
+  socket.SetPhysicalAddress (m_staDevice.Get (0)->GetAddress ());
+  socket.SetProtocol (1);
+
+  // give packet socket powers to nodes.
+  PacketSocketHelper packetSocket;
+  packetSocket.Install (m_staNode);
+  packetSocket.Install (m_apNode);
+
+  Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient> ();
+  client->SetAttribute ("PacketSize", UintegerValue (m_payloadSize));
+  client->SetAttribute ("MaxPackets", UintegerValue (1));
+  client->SetAttribute ("Interval", TimeValue (MicroSeconds (0)));
+  client->SetRemote (socket);
+  m_apNode.Get (0)->AddApplication (client);
+  client->SetStartTime (Seconds (0.5));
+  client->SetStopTime (Seconds (1.0));
+
+  Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer> ();
+  server->SetLocal (socket);
+  m_staNode.Get (0)->AddApplication (server);
+  server->SetStartTime (Seconds (0.0));
+  server->SetStopTime (Seconds (1.0));
+}
+
+void
+WifiChannelSwitchingTest::ChannelSwitch (void)
+{
+  NS_LOG_INFO ("CHANNEL SWITCH\n");
+  Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/$ns3::WifiPhy/ChannelSettings",
+               StringValue ("{1, 20, BAND_2_4GHZ, 0}"));
+}
+
+void
+WifiChannelSwitchingTest::StateChange (uint32_t nodeId, ns3::Time start, ns3::Time duration,
+                                       WifiPhyState state)
+{
+  if (state == WifiPhyState::SWITCHING)
+    {
+      m_channelSwitchCount[nodeId]++;
+    }
+}
+
+void
+WifiChannelSwitchingTest::DoRun (void)
+{
+  Time simulationTime (Seconds (6.0));
+
+  RngSeedManager::SetSeed (1);
+  RngSeedManager::SetRun (40);
+  int64_t streamNumber = 100;
+
+  m_apNode.Create (1);
+  m_staNode.Create (1);
+
+  Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel> ();
+  Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel> ();
+  spectrumChannel->AddPropagationLossModel (lossModel);
+  Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
+  spectrumChannel->SetPropagationDelayModel (delayModel);
+
+  SpectrumWifiPhyHelper phy;
+  phy.SetChannel (spectrumChannel);
+  phy.Set ("ChannelSettings", StringValue ("{36, 20, BAND_5GHZ, 0}"));
+
+  WifiHelper wifi;
+  wifi.SetStandard (WIFI_STANDARD_80211ax);
+  wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
+
+  WifiMacHelper mac;
+  mac.SetType ("ns3::StaWifiMac",
+               "Ssid", SsidValue (Ssid ("channel-switching-test")));
+
+  m_staDevice = wifi.Install (phy, mac, m_staNode);
+
+  mac.SetType ("ns3::ApWifiMac",
+               "Ssid", SsidValue (Ssid ("channel-switching-test")),
+               "EnableBeaconJitter", BooleanValue (false));
+
+  m_apDevice = wifi.Install (phy, mac, m_apNode);
+
+  // Assign fixed streams to random variables in use
+  wifi.AssignStreams (m_apDevice, streamNumber);
+
+  MobilityHelper mobility;
+  Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator> ();
+
+  positionAlloc->Add (Vector (0.0, 0.0, 0.0));
+  positionAlloc->Add (Vector (5.0, 0.0, 0.0));
+  mobility.SetPositionAllocator (positionAlloc);
+
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (m_apNode);
+  mobility.Install (m_staNode);
+
+  SendPacket ();
+
+  Config::ConnectWithoutContext ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/$ns3::StaWifiMac/Assoc",
+                                 MakeCallback (&WifiChannelSwitchingTest::Associated, this));
+  Config::ConnectWithoutContext ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/PhyTxPsduBegin",
+                                 MakeCallback (&WifiChannelSwitchingTest::Transmit, this));
+  Config::ConnectWithoutContext ("/NodeList/*/ApplicationList/0/$ns3::PacketSocketServer/Rx",
+                                 MakeCallback (&WifiChannelSwitchingTest::L7Receive, this));
+  Config::ConnectWithoutContext ("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phy/State/State",
+                                 MakeCallback (&WifiChannelSwitchingTest::StateChange, this).Bind (0));
+  Config::ConnectWithoutContext ("/NodeList/1/DeviceList/*/$ns3::WifiNetDevice/Phy/State/State",
+                                 MakeCallback (&WifiChannelSwitchingTest::StateChange, this).Bind (1));
+
+  Simulator::Stop (Seconds (2));
+  Simulator::Run ();
+
+  NS_TEST_EXPECT_MSG_EQ (+m_assocCount, 2, "STA did not associate twice");
+  NS_TEST_EXPECT_MSG_EQ (+m_txCount, 2, "The QoS Data frame should have been transmitted twice by the AP");
+  NS_TEST_EXPECT_MSG_EQ (m_rxBytes, m_payloadSize, "The QoS Data frame should have been received once by the STA");
+  NS_TEST_EXPECT_MSG_EQ (+m_channelSwitchCount[0], 1, "AP had to perform one channel switch");
+  NS_TEST_EXPECT_MSG_EQ (+m_channelSwitchCount[1], 1, "STA had to perform one channel switch");
+
+  Simulator::Destroy ();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Block Ack Test Suite
+ */
+class WifiChannelSwitchingTestSuite : public TestSuite
+{
+public:
+  WifiChannelSwitchingTestSuite ();
+};
+
+WifiChannelSwitchingTestSuite::WifiChannelSwitchingTestSuite ()
+  : TestSuite ("wifi-channel-switching", UNIT)
+{
+  AddTestCase (new WifiChannelSwitchingTest, TestCase::QUICK);
+}
+
+static WifiChannelSwitchingTestSuite g_issue211TestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.36/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.35/src/wifi/test/wifi-mac-ofdma-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/wifi-mac-ofdma-test.cc	2022-04-30 18:23:58.222735200 -0700
@@ -55,7 +55,7 @@
  * (when all BA agreements have been established). Afterwards, it cycles through UL_MU_TX
  * (with a BSRP Trigger Frame), UL_MU_TX (with a Basic Trigger Frame) and DL_MU_TX.
  * This scheduler requires that 4 stations are associated with the AP.
- * 
+ *
  */
 class TestMultiUserScheduler : public MultiUserScheduler
 {
@@ -81,8 +81,8 @@
 
   TxFormat m_txFormat;              //!< the format of next transmission
   TriggerFrameType m_ulTriggerType; //!< Trigger Frame type for UL MU
-  Ptr<WifiMacQueueItem> m_trigger;  //!< Trigger Frame to send
-  Time m_tbPpduDuration;            //!< Duration of the solicited TB PPDUs
+  CtrlTriggerHeader m_trigger;      //!< Trigger Frame to send
+  WifiMacHeader m_triggerHdr;       //!< MAC header for Trigger Frame
   WifiTxVector m_txVector;          //!< the TX vector for MU PPDUs
   WifiTxParameters m_txParams;      //!< TX parameters
   WifiPsduMap m_psduMap;            //!< the DL MU PPDU to transmit
@@ -136,10 +136,10 @@
                                         ? TriggerFrameType::BSRP_TRIGGER
                                         : TriggerFrameType::BASIC_TRIGGER);
 
-      CtrlTriggerHeader trigger (ulTriggerType, m_txVector);
+      m_trigger = CtrlTriggerHeader (ulTriggerType, m_txVector);
 
       WifiTxVector txVector = m_txVector;
-      txVector.SetGuardInterval (trigger.GetGuardInterval ());
+      txVector.SetGuardInterval (m_trigger.GetGuardInterval ());
 
       uint32_t ampduSize = (ulTriggerType == TriggerFrameType::BSRP_TRIGGER ? m_sizeOf8QosNull : 3500);
 
@@ -147,27 +147,28 @@
                                                     m_apMac->GetWifiPhy ()->GetPhyBand (),
                                                     m_apMac->GetStaList ().begin ()->first);
 
-      uint16_t length = HePhy::ConvertHeTbPpduDurationToLSigLength (duration,
-                                                                    m_apMac->GetWifiPhy ()->GetPhyBand ());
-      trigger.SetUlLength (length);
-      m_heFem->SetTargetRssi (trigger);
+      uint16_t length;
+      std::tie (length, duration) = HePhy::ConvertHeTbPpduDurationToLSigLength (duration,
+                                                                                m_trigger.GetHeTbTxVector (m_trigger.begin ()->GetAid12 ()),
+                                                                                m_apMac->GetWifiPhy ()->GetPhyBand ());
+      m_trigger.SetUlLength (length);
 
       Ptr<Packet> packet = Create<Packet> ();
-      packet->AddHeader (trigger);
+      packet->AddHeader (m_trigger);
 
-      WifiMacHeader hdr (WIFI_MAC_CTL_TRIGGER);
-      hdr.SetAddr1 (Mac48Address::GetBroadcast ());
-      hdr.SetAddr2 (m_apMac->GetAddress ());
-      hdr.SetDsNotTo ();
-      hdr.SetDsNotFrom ();
+      m_triggerHdr = WifiMacHeader (WIFI_MAC_CTL_TRIGGER);
+      m_triggerHdr.SetAddr1 (Mac48Address::GetBroadcast ());
+      m_triggerHdr.SetAddr2 (m_apMac->GetAddress ());
+      m_triggerHdr.SetDsNotTo ();
+      m_triggerHdr.SetDsNotFrom ();
 
-      m_trigger = Create<WifiMacQueueItem> (packet, hdr);
+      auto item = Create<WifiMacQueueItem> (packet, m_triggerHdr);
 
       m_txParams.Clear ();
       // set the TXVECTOR used to send the Trigger Frame
-      m_txParams.m_txVector = m_apMac->GetWifiRemoteStationManager ()->GetRtsTxVector (hdr.GetAddr1 ());
+      m_txParams.m_txVector = m_apMac->GetWifiRemoteStationManager ()->GetRtsTxVector (m_triggerHdr.GetAddr1 ());
 
-      if (!m_heFem->TryAddMpdu (m_trigger, m_txParams, m_availableTime)
+      if (!m_heFem->TryAddMpdu (item, m_txParams, m_availableTime)
           || (m_availableTime != Time::Min ()
               && m_txParams.m_protection->protectionTime
                  + m_txParams.m_txDuration     // TF tx time
@@ -182,7 +183,6 @@
 
       m_txFormat = UL_MU_TX;
       m_ulTriggerType = ulTriggerType;
-      m_tbPpduDuration = duration;
     }
   else if (m_txFormat == UL_MU_TX)
     {
@@ -205,10 +205,9 @@
               return SU_TX;
             }
 
-          WifiMacQueueItem::ConstIterator queueIt;
           Ptr<WifiMacQueueItem> mpdu = m_apMac->GetQosTxop (AC_BE)->GetNextMpdu (peeked, m_txParams,
                                                                                  m_availableTime,
-                                                                                 m_initialFrame, queueIt);
+                                                                                 m_initialFrame);
           if (mpdu == 0)
             {
               NS_LOG_DEBUG ("Not enough time to send frames to all the stations");
@@ -216,7 +215,7 @@
             }
 
           std::vector<Ptr<WifiMacQueueItem>> mpduList;
-          mpduList = m_heFem->GetMpduAggregator ()->GetNextAmpdu (mpdu, m_txParams, m_availableTime, queueIt);
+          mpduList = m_heFem->GetMpduAggregator ()->GetNextAmpdu (mpdu, m_txParams, m_availableTime);
 
           if (mpduList.size () > 1)
             {
@@ -250,7 +249,7 @@
 
   uint16_t bw = m_apMac->GetWifiPhy ()->GetChannelWidth ();
 
-  m_txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);  
+  m_txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);
   m_txVector.SetChannelWidth (bw);
   m_txVector.SetGuardInterval (m_apMac->GetHeConfiguration ()->GetGuardInterval ().GetNanoSeconds ());
   m_txVector.SetTxPowerLevel (GetWifiRemoteStationManager ()->GetDefaultTxPowerLevel ());
@@ -303,7 +302,7 @@
 TestMultiUserScheduler::ComputeUlMuInfo (void)
 {
   NS_LOG_FUNCTION (this);
-  return UlMuInfo {m_trigger, m_tbPpduDuration, std::move (m_txParams)};
+  return UlMuInfo {m_trigger, m_triggerHdr, std::move (m_txParams)};
 }
 
 
@@ -315,7 +314,7 @@
  *
  * Run this test with:
  *
- * NS_LOG="WifiMacOfdmaTestSuite=info|prefix_time|prefix_node" ./waf --run "test-runner --suite=wifi-mac-ofdma"
+ * NS_LOG="WifiMacOfdmaTestSuite=info|prefix_time|prefix_node" ./ns3 run "test-runner --suite=wifi-mac-ofdma"
  *
  * to print the list of transmitted frames only, along with the TX time and the
  * node prefix. Replace 'info' with 'debug' if you want to print the debug messages
@@ -479,14 +478,14 @@
   if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
     {
       auto dev = DynamicCast<WifiNetDevice> (m_apDevice);
-      Ptr<WifiMacQueue> queue = DynamicCast<RegularWifiMac> (dev->GetMac ())->GetQosTxop (AC_BE)->GetWifiMacQueue ();
+      Ptr<WifiMacQueue> queue = dev->GetMac ()->GetQosTxop (AC_BE)->GetWifiMacQueue ();
       m_flushed = 0;
       for (auto it = queue->begin (); it != queue->end (); )
         {
           auto tmp = it++;
           if (!(*tmp)->IsInFlight ())
             {
-              queue->Remove (tmp);
+              queue->Remove (*tmp, false);
               m_flushed++;
             }
         }
@@ -502,7 +501,7 @@
 
           if (dev->GetAddress () == sender)
             {
-              Ptr<QosTxop> qosTxop = DynamicCast<RegularWifiMac> (dev->GetMac ())->GetQosTxop (AC_BE);
+              Ptr<QosTxop> qosTxop = dev->GetMac ()->GetQosTxop (AC_BE);
 
               if (m_muEdcaParameterSet.muTimer > 0 && m_muEdcaParameterSet.muAifsn > 0)
                 {
@@ -589,11 +588,11 @@
       uint8_t tid = hdr.GetQosTid ();
       if (tid == 0)
         {
-          NS_TEST_EXPECT_MSG_GT (hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_GT (+hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
         }
       else
         {
-          NS_TEST_EXPECT_MSG_EQ (hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_EQ (+hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
         }
     }
   tEnd = m_txPsdus[0].endTx;
@@ -615,11 +614,11 @@
       uint8_t tid = hdr.GetQosTid ();
       if (tid == 0)
         {
-          NS_TEST_EXPECT_MSG_GT (hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_GT (+hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
         }
       else
         {
-          NS_TEST_EXPECT_MSG_EQ (hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_EQ (+hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
         }
     }
   tStart = m_txPsdus[2].startTx;
@@ -639,11 +638,11 @@
       uint8_t tid = hdr.GetQosTid ();
       if (tid == 0)
         {
-          NS_TEST_EXPECT_MSG_GT (hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_GT (+hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
         }
       else
         {
-          NS_TEST_EXPECT_MSG_EQ (hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_EQ (+hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
         }
     }
   tStart = m_txPsdus[3].startTx;
@@ -663,11 +662,11 @@
       uint8_t tid = hdr.GetQosTid ();
       if (tid == 0)
         {
-          NS_TEST_EXPECT_MSG_GT (hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_GT (+hdr.GetQosQueueSize (), 0, "Expected a non null queue size for TID " << +tid);
         }
       else
         {
-          NS_TEST_EXPECT_MSG_EQ (hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
+          NS_TEST_EXPECT_MSG_EQ (+hdr.GetQosQueueSize (), 0, "Expected a null queue size for TID " << +tid);
         }
     }
   tStart = m_txPsdus[4].startTx;
@@ -835,7 +834,7 @@
       tStart = m_txPsdus[13].startTx;
       NS_TEST_EXPECT_MSG_LT (tEnd + sifs, tStart, "First Block Ack Request sent too early");
       NS_TEST_EXPECT_MSG_LT (tStart, tEnd + sifs + tolerance, "First Block Ack Request sent too late");
-      
+
       // A second STA sends a Block Ack a SIFS after the reception of the Block Ack Request
       NS_TEST_EXPECT_MSG_EQ ((m_txPsdus[14].psduMap.size () == 1
                               && m_txPsdus[14].psduMap[SU_STA_ID]->GetHeader (0).IsBlockAck ()),
@@ -853,7 +852,7 @@
       tStart = m_txPsdus[15].startTx;
       NS_TEST_EXPECT_MSG_LT (tEnd + sifs, tStart, "Second Block Ack Request sent too early");
       NS_TEST_EXPECT_MSG_LT (tStart, tEnd + sifs + tolerance, "Second Block Ack Request sent too late");
-      
+
       // A third STA sends a Block Ack a SIFS after the reception of the Block Ack Request
       NS_TEST_EXPECT_MSG_EQ ((m_txPsdus[16].psduMap.size () == 1
                               && m_txPsdus[16].psduMap[SU_STA_ID]->GetHeader (0).IsBlockAck ()),
@@ -871,7 +870,7 @@
       tStart = m_txPsdus[17].startTx;
       NS_TEST_EXPECT_MSG_LT (tEnd + sifs, tStart, "Third Block Ack Request sent too early");
       NS_TEST_EXPECT_MSG_LT (tStart, tEnd + sifs + tolerance, "Third Block Ack Request sent too late");
-      
+
       // A fourth STA sends a Block Ack a SIFS after the reception of the Block Ack Request
       NS_TEST_EXPECT_MSG_EQ ((m_txPsdus[18].psduMap.size () == 1
                               && m_txPsdus[18].psduMap[SU_STA_ID]->GetHeader (0).IsBlockAck ()),
@@ -1092,8 +1091,8 @@
 OfdmaAckSequenceTest::DoRun (void)
 {
   RngSeedManager::SetSeed (1);
-  RngSeedManager::SetRun (2);
-  int64_t streamNumber = 100;
+  RngSeedManager::SetRun (1);
+  int64_t streamNumber = 20;
 
   NodeContainer wifiApNode;
   wifiApNode.Create (1);
@@ -1114,21 +1113,20 @@
   switch (m_channelWidth)
     {
       case 20:
-        phy.Set ("ChannelNumber", UintegerValue (36));
+        phy.Set ("ChannelSettings", StringValue ("{36, 20, BAND_5GHZ, 0}"));
         break;
       case 40:
-        phy.Set ("ChannelNumber", UintegerValue (38));
+        phy.Set ("ChannelSettings", StringValue ("{38, 40, BAND_5GHZ, 0}"));
         break;
       case 80:
-        phy.Set ("ChannelNumber", UintegerValue (42));
+        phy.Set ("ChannelSettings", StringValue ("{42, 80, BAND_5GHZ, 0}"));
         break;
       case 160:
-        phy.Set ("ChannelNumber", UintegerValue (50));
+        phy.Set ("ChannelSettings", StringValue ("{50, 160, BAND_5GHZ, 0}"));
         break;
       default:
         NS_ABORT_MSG ("Invalid channel bandwidth (must be 20, 40, 80 or 160)");
     }
-  phy.Set ("ChannelWidth", UintegerValue (m_channelWidth));
 
   Config::SetDefault ("ns3::HeConfiguration::MuBeAifsn",
                       UintegerValue (m_muEdcaParameterSet.muAifsn));
@@ -1150,7 +1148,7 @@
   Config::SetDefault ("ns3::WifiMacQueue::MaxDelay", TimeValue (Seconds (2)));
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211ax);
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
 
   WifiMacHelper mac;
